# Two dimensional generation of random spectral data
# Use of ANOVA to detect spectral characteristics
# Store results in a matrix
store1=matrix(data=0, ncol=10, nrow=7*10*10) 
rowcount=0 
distclass<-c(128,64,32,16,8,NA)
for (m in 0:6) {
beta=m/2
for (rep in 1:10) {
x1=runif(65536,0,2*pi)
x2=rnorm(65536, 0, 1)
x3=matrix(data=c(1:256), ncol=1, nrow=256)
x4=matrix(data=c(1:256), ncol=1, nrow=256)
f=matrix(ncol=256, nrow=256)
for (i in 1:256)
for (j in 1:256)
f[i,j]=x3[i,1]^2+x4[j,1]^2
af=(1/(f^(beta/2)))*x2
seq=af*cos(x1)+1i*af*sin(x1)
y=Re(fft(seq, inverse=TRUE))
tmps=spectrum(y, plot=F, detrend=F)
reg=lm(log(tmps$spec)~log(tmps$freq))
reg$coefficients[2]
# Generate random sample location
sx1=(runif(1000,1,256))
sx2=(runif(1000,1,256))
sy= matrix(data=c(0), ncol=1, nrow=1000)
# Sample the 2D simulated data
for (i in 1:1000)
sy[i]=y[round(sx1[i]),round(sx2[i])]
# Create a matrix to store ANOVA results
#sanova= matrix(data=c(0), ncol=5, nrow=12)
sanova=0
# Shift the spatial windows and perform the ANOVA 12 times 
for (k in 1:12) {
sx1=sx1+40 
sx2=sx2+40
# Create spatial window classes
d128=1000*round(sx1/128)+ round(sx2/128)
d64= 1000*round(sx1/64)+ round(sx2/64)
d32= 1000*round(sx1/32)+ round(sx2/32)
d16= 1000*round(sx1/16)+ round(sx2/16)
d8 = 1000*round(sx1/8)+ round(sx2/8)
d4 = 1000*round(sx1/4)+ round(sx2/4)
f128<-factor(d128)
f64<- factor(d64)
f32<- factor(d32)
f16<- factor(d16)
f8 <- factor(d8)
f4 <- factor(d4)

#  ANOVA on the sampled data
tmp<-lm(sy~f128 + f64 + f32 +f16 +f8) # +f4)
sanova=sanova+anova(tmp)
}
sanova=sanova/12
# Slope of log variance on log distance class
tmp3<-lm(log(sanova[,3])~log(distclass), na.action = na.omit)
# Store results 
for (i in 1:6) { 
store1[rowcount+i,1]<- beta
store1[rowcount+i,2]<- reg$coefficients[2]
store1[rowcount+i,3]<- tmp3$coefficients[2]
store1[rowcount+i,4]<- rep
store1[rowcount+i,5]<- distclass[i]
for (j in 1:5) {   
store1[rowcount+i,5+j]=sanova[i,j]}
} # end store loop
rowcount=rowcount+6  
} # end rep loop
} # end beta loop   

store1
# output beta, m, rep, Spectrum Beta, ANOVA statistics

write.table(store1,file="C:\\Documents and Settings\\MTB\\My Documents\\Rocky Shores 2003\\SpatialSpectralAnalysis\\SpectralSynthesis\\BetaANOVA1000b.csv",
      append = FALSE, , sep = ",", col.names=FALSE)